//#ifdef SPRINT_AUDIO
package device;

import com.sprintpcs.media.*;
import genplay.util.*;
import genplay.vp.core.GPCanvas;



public class SprintMediaEngine implements MediaImplementation,PlayerListener {

	Clip clips[];
	
	public SprintMediaEngine(String[] names) {

		clips = new Clip[names.length];
		for (int c = 0; c < names.length; c++) {
		    try {
				if (clips[c] == null) {
					byte[] data = GPCanvas.loadBytes(names[c]);
					clips[c] = new Clip(data, "audio/midi",1,0);
				} 
			} catch (Exception e) { }
		}
		Player.addPlayerListener(this);
		
	}

	public void playSound(int s) {
		//#ifdef DEBUG
        try {
			if (clips[s] != null) {
        //#endif
				
				stopSound(false);
				Player.play(clips[s],0);
		//#ifdef DEBUG
			} else {
				////System.out.println("SprintMEDIA: Tried to play a dead sound");
			}
		} catch (Exception e) {
			////System.out.println("SprintSPlay: " + e);
		}
		//#endif
	}
	
	public void stopSound(boolean force) {
		//#ifdef DEBUG
		try {
		//#endif
			Player.stop();
		//#ifdef DEBUG
		} catch (Exception e) {
			System.out.println("SprintSStop: " + e);
		}
		//#endif
	}

	public void vibrate(int ms) {
		Vibrator.vibrate(ms);
	}

	public void playerUpdate(int event, Object data) {
		if (event == PlayerListener.END_OF_DATA) {
			stopSound(false);
		}
	}
}
//#endif