package genplay.util;

import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.midlet.MIDlet;

import genplay.vp.game.Game;
import genplay.vp.logi.Strings;
import device.*;

/*
 * Author: E Scott Cragg Email: scragg@genplay.com IM: EridanMan
 * 
 * 8-1- screw Generalization, optimized for speed/size
 *  
 */
public class Media extends Thread {

	private static final long WARNING_SOUND_DEAD_TIME = 3000;
	
	public static final int SND_DEAL1 = 0;
	public static final int SND_DEAL2 = 1;
	public static final int SND_DEAL3 = 2;
	public static final int SND_DEAL4 = 3;
	public static final int SND_DEAL5 = 4;
	public static final int SND_JACKPOT = 5;
	public static final int SND_ERROR = 6;
	public static final int SND_PAT = 7;
	public static final int theme = 8;
	public static final int SND_WIN3 = 9;
	public static final int SND_WIN5 = 10;
	public static final int SND_WIN = 11;
	public static final int SND_END = 12;
	public static final int SND_WARNING = 13;
	public static final int NONE = -1;

	private static MediaImplementation media;
	private static int soundToPlay;
	private static long warningSoundTime;
	
	// Media File names:
	public static final String[] MEDIA_FILES = {"/deal1.mid",
												"/deal2.mid",
												"/deal3.mid",
												"/deal4.mid",
												"/deal5.mid",
			   									"/jackpot.mid",
												"/error.mid",
												"/pat.mid",
												"/theme.mid",
												"/win3.mid",
												"/win5.mid",
												"/win.mid",
												"/end.mid",
			   									"/warning.mid"};


	public static void initialize() {
		//#ifdef SAMSUNG_AUDIO
		media = new Samsung20MediaEngine(Media.MEDIA_FILES);
		//#elifdef SPRINT_AUDIO
		media = new SprintMediaEngine(Media.MEDIA_FILES);
		//#elifdef NOKIA_MID_AUDIO
		media = new Nokia60MediaEngine(Media.MEDIA_FILES);
		//#elifdef NOKIA_TNE_AUDIO
		media = new DummyMediaEngine();
		//media = new Nokia40MediaEngine(Media.MEDIA_FILES);
		//#elifdef MMAPI_AUDIO
		media = new MIDP20MediaEngine(Media.MEDIA_FILES);
		//#else 
		media = new DummyMediaEngine();
		//#endif
	}

	public static void soundPlay(int soundId, int priority, boolean block) {
		if ((0 <= soundId) && (soundId < Media.MEDIA_FILES.length)
			&& System.currentTimeMillis() > warningSoundTime + WARNING_SOUND_DEAD_TIME) {

			if (Game.avSetting == Game.AV_ALL ||
				    Game.avSetting == Game.AV_SOUND) {
				
				soundToPlay = soundId;
				Media playThread = new Media();
				if (soundId == SND_WARNING) warningSoundTime = System.currentTimeMillis();
				playThread.start();
				//#ifdef DEBUG
				System.out.println("PLAYING " + MEDIA_FILES[soundId]);
				//#endif
				try {
					if (block) playThread.join();
				} catch (Exception e) {
					return;
				}
				
			}
			//#ifdef DEBUG
			else {
				System.out.println("FAILED: Sound is Off");
			}
			//#endif
		}
	}

	public static void vibratePlay(int time) {
		if (Game.avSetting == Game.AV_ALL ||
			Game.avSetting == Game.AV_VIBRATE) {
			media.vibrate(time);
		}
	}

	public static void stop() {
		media.stopSound(false);
	}

	public void run() {
		synchronized (media) {
			media.stopSound(false);
			media.playSound(soundToPlay);
		}
	}
}