
package genplay.vp.core;

import genplay.util.Media;

public class ThreadHandler extends Thread {

	// Thread modes:
	public static final int THREAD_GAME_HANDLER = 0;
	public static final int THREAD_ANIMATION_HANDLER = 1;
	public static final int NUM_THREAD_TYPES = 2;
	
	// The mode of the currently executing Thread
	private int localMode;
	private long startTime;
	private long nextDelay;
	
	public static Thread[] threads = new Thread[NUM_THREAD_TYPES];
	
	public ThreadHandler(int runMode) {
		localMode = runMode;
		threads[runMode] = this;
	}
	
	public void run() {
		//#ifdef DEBUG
		try {
		//#endif
			startTime = System.currentTimeMillis();
			nextDelay = 0;
			do {
				switch (localMode) {
					case THREAD_GAME_HANDLER:
						VPHandler.thread();
						break;
					case THREAD_ANIMATION_HANDLER:
						try {
							Thread.sleep(nextDelay);
						} catch (Exception e) { }
						nextDelay = MenuScreen.thread(startTime);
						break;
				}
			} while (!VPHandler.shutDown);
		//#ifdef DEBUG
		} catch (Exception e) {
			System.out.println("ThreadHandler: " + e);
			e.printStackTrace();
		}
		//#endif
	}
}
